# treeplaylist.py
#
# Copyright (C) 2006 - Fabien Carrion <fabien.carrion@gmail.com>
# Copyright (C) 2006 - Jon Oberheide <jon@oberheide.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.

import pygtk, gtk, gtk.glade
from configdata import ConfigData

class TreePlayList:
    def __init__(self, configdata, glade):
        self.configdata = configdata
	self.glade = glade
        self.treeview = self.glade.get_widget('source_list_treeview')
        renderer = gtk.CellRendererPixbuf()
        column = gtk.TreeViewColumn('Icon', renderer, pixbuf=1, sensitive=5, visible=5)
        self.treeview.append_column(column)
        renderer = gtk.CellRendererText()
        column = gtk.TreeViewColumn('Name', renderer, text=2, sensitive=5, visible=5)
        self.treeview.append_column(column)

    def setConfigdata(self, configdata):
        self.configdata = configdata

    def setShell(self, shell):
        self.shell = shell
        self.source_model = self.shell.get_property("sourcelist-model")
        self.treeview.set_model(self.source_model) # XXX causes crashes???

    def activate(self, player):
        iter = self.source_model.get_iter_first()
        while iter is not None:
            str = self.source_model.get_value(iter, 2)
            if str == self.configdata.playlist:
                source = self.source_model.get_value(iter, 3)
                player.set_playing_source(source)
                break
            iter = self.source_model.iter_next(iter)

    def load_config(self):
        iter = self.source_model.get_iter_first()
        while iter is not None:
            str = self.source_model.get_value(iter, 2)
            if str == self.configdata.playlist:
                selection = self.treeview.get_selection()
                selection.select_iter(iter)
                break
            iter = self.source_model.iter_next(iter)

    def save_config(self):
        selection = self.treeview.get_selection()
        (ref, iter) = selection.get_selected()
        if iter is not None:
            self.configdata.playlist = self.source_model.get_value(iter, 2)
